// Code generated by mockery v2.42.3. DO NOT EDIT.

package mock_audit_logger

import (
	context "context"

	auditlog "gitlab.com/commonground/nlx/fsc-nlx/common/auditlog"

	mock "github.com/stretchr/testify/mock"
)

// MockAuditLogger is an autogenerated mock type for the AuditLogger type
type MockAuditLogger struct {
	mock.Mock
}

type MockAuditLogger_Expecter struct {
	mock *mock.Mock
}

func (_m *MockAuditLogger) EXPECT() *MockAuditLogger_Expecter {
	return &MockAuditLogger_Expecter{mock: &_m.Mock}
}

// CreateRecords provides a mock function with given fields: ctx, records
func (_m *MockAuditLogger) CreateRecords(ctx context.Context, records auditlog.Records) error {
	ret := _m.Called(ctx, records)

	if len(ret) == 0 {
		panic("no return value specified for CreateRecords")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, auditlog.Records) error); ok {
		r0 = rf(ctx, records)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// MockAuditLogger_CreateRecords_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'CreateRecords'
type MockAuditLogger_CreateRecords_Call struct {
	*mock.Call
}

// CreateRecords is a helper method to define mock.On call
//   - ctx context.Context
//   - records auditlog.Records
func (_e *MockAuditLogger_Expecter) CreateRecords(ctx interface{}, records interface{}) *MockAuditLogger_CreateRecords_Call {
	return &MockAuditLogger_CreateRecords_Call{Call: _e.mock.On("CreateRecords", ctx, records)}
}

func (_c *MockAuditLogger_CreateRecords_Call) Run(run func(ctx context.Context, records auditlog.Records)) *MockAuditLogger_CreateRecords_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(context.Context), args[1].(auditlog.Records))
	})
	return _c
}

func (_c *MockAuditLogger_CreateRecords_Call) Return(_a0 error) *MockAuditLogger_CreateRecords_Call {
	_c.Call.Return(_a0)
	return _c
}

func (_c *MockAuditLogger_CreateRecords_Call) RunAndReturn(run func(context.Context, auditlog.Records) error) *MockAuditLogger_CreateRecords_Call {
	_c.Call.Return(run)
	return _c
}

// ListRecords provides a mock function with given fields: ctx, args
func (_m *MockAuditLogger) ListRecords(ctx context.Context, args *auditlog.ListRecordsArgs) (auditlog.Records, error) {
	ret := _m.Called(ctx, args)

	if len(ret) == 0 {
		panic("no return value specified for ListRecords")
	}

	var r0 auditlog.Records
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *auditlog.ListRecordsArgs) (auditlog.Records, error)); ok {
		return rf(ctx, args)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *auditlog.ListRecordsArgs) auditlog.Records); ok {
		r0 = rf(ctx, args)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(auditlog.Records)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *auditlog.ListRecordsArgs) error); ok {
		r1 = rf(ctx, args)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// MockAuditLogger_ListRecords_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'ListRecords'
type MockAuditLogger_ListRecords_Call struct {
	*mock.Call
}

// ListRecords is a helper method to define mock.On call
//   - ctx context.Context
//   - args *auditlog.ListRecordsArgs
func (_e *MockAuditLogger_Expecter) ListRecords(ctx interface{}, args interface{}) *MockAuditLogger_ListRecords_Call {
	return &MockAuditLogger_ListRecords_Call{Call: _e.mock.On("ListRecords", ctx, args)}
}

func (_c *MockAuditLogger_ListRecords_Call) Run(run func(ctx context.Context, args *auditlog.ListRecordsArgs)) *MockAuditLogger_ListRecords_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(context.Context), args[1].(*auditlog.ListRecordsArgs))
	})
	return _c
}

func (_c *MockAuditLogger_ListRecords_Call) Return(_a0 auditlog.Records, _a1 error) *MockAuditLogger_ListRecords_Call {
	_c.Call.Return(_a0, _a1)
	return _c
}

func (_c *MockAuditLogger_ListRecords_Call) RunAndReturn(run func(context.Context, *auditlog.ListRecordsArgs) (auditlog.Records, error)) *MockAuditLogger_ListRecords_Call {
	_c.Call.Return(run)
	return _c
}

// NewMockAuditLogger creates a new instance of MockAuditLogger. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockAuditLogger(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockAuditLogger {
	mock := &MockAuditLogger{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
